# This file is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as 
# published by the Free Software Foundation here:
# (http://www.gnu.org/licenses/gpl-2.0.html)
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

DEPENDS = bzip2,glibc,zlib
ARCH = x86_64
URL = https://www.perl.org/
BRIEF = Perl programming language
DESC = Perl 5 is a highly capable, feature-rich programming language
SNAPVER = 2

ARCHIVE := $(PWD)/SRC/$(shell ls SRC|egrep '(bz2|gz|tar|xz)$$'|tail -1)
TYPE := $(shell file -ib $(ARCHIVE)|cut -d';' -f1|tr -d '\n')
SRCDIR := $(shell tar -tf $(ARCHIVE)|head -1|sed 's/\/.*//')
PATCHDIR := $(PWD)/SRC/patches
VERSION := $(shell echo $(SRCDIR)|egrep -o '\-[0-9].*'|sed 's/^-//')-$(SNAPVER)

include /usr/share/snap/Makefile.snaplinux

$(SRCDIR)/Configure: $(ARCHIVE)
	@if [ '$(TYPE)' == 'application/x-bzip2' ]; then \
		tar -jxf $(ARCHIVE); \
	elif [ '$(TYPE)' == 'application/x-gzip' ]; then \
		tar -zxf $(ARCHIVE); \
	elif [ '$(TYPE)' == 'application/x-tar' ]; then \
		tar -xf $(ARCHIVE); \
	elif [ '$(TYPE)' == 'application/x-xz' ]; then \
		tar -xf $(ARCHIVE); \
	else \
		echo 'Unable to determine archive type'; \
		exit 1; \
	fi
	@touch $(SRCDIR)/Configure

$(SRCDIR)/config.sh: $(SRCDIR)/Configure
	@cd $(SRCDIR) && for patch in `find $(PATCHDIR) -name \*.patch`; do \
		patch --verbose -Np1 -i $$patch; \
	done
	@cd $(SRCDIR); \
	BUILD_ZLIB=False BUILD_BZIP2=0 ./Configure \
		-des \
		-Dprefix=/usr \
		-Dsiteprefix=/usr/local \
		-Dvendorprefix=/usr \
		-Dman1dir=/usr/share/man/man1 \
		-Dman3dir=/usr/share/man/man3 \
		-Dpager="/usr/bin/less -isR" \
		-Duseshrplib \
		-Darchname=$(ARCH)

$(SRCDIR)/perl: $(SRCDIR)/config.sh
	@cd $(SRCDIR) && BUILD_ZLIB=False BUILD_BZIP2=0 make

$(ROOT): $(SRCDIR)/perl
	@if [ -d $(ROOT) ]; then \
		touch $(ROOT); \
	else \
		mkdir -v $(ROOT); \
	fi

	@cd $(SRCDIR) && BUILD_ZLIB=False BUILD_BZIP2=0 \
		make install DESTDIR=$(ROOT) && \
	rm -v $(ROOT)/usr/share/man/man1/{perlthanks,pstruct}.1 && \
	ln -sv c2ph.1 $(ROOT)/usr/share/man/man1/pstruct.1 && \
	ln -sv perlbug.1 $(ROOT)/usr/share/man/man1/perlthanks.1 && \
	rm -rv $(ROOT)/usr/share/man/man3/DB_File* \
		$(ROOT)/usr/lib/perl5/5.24.0/x86_64/auto/DB_File \
		$(ROOT)/usr/lib/perl5/5.24.0/x86_64/DB_File.pm && \
	rm -rv $(ROOT)/usr/share/man/man3/GDBM_File* \
		$(ROOT)/usr/lib/perl5/5.24.0/x86_64/auto/GDBM_File \
		$(ROOT)/usr/lib/perl5/5.24.0/x86_64/GDBM_File.pm

test: $(ROOT)
	@cd $(SRCDIR) && make -k test

clean:
	@rm -rvf $(ROOT) \
		$(SNAPINFO) \
		$(MANIFEST) \
		$(FILES) \
		$(SRCDIR)

